#
# Conditional build:
%bcond_without	doc	# HTML (sphinx-based) documentation
%bcond_without	tests	# test suite

Summary:	Extensions to the Python unit testing framework
Summary(pl.UTF-8):	Rozszerzenie szkieletu testów jednostkowych Pythona
Name:		python3-testtools
Version:	2.7.2
Release:	2
License:	MIT
Group:		Development/Tools
#Source0Download: https://pypi.org/simple/testtools/
Source0:	https://files.pythonhosted.org/packages/source/t/testtools/testtools-%{version}.tar.gz
# Source0-md5:	35777a93ea85b59160380595b8cf315e
URL:		https://github.com/testing-cabal/testtools
BuildRequires:	python3-build
BuildRequires:	python3-devel >= 1:3.8
BuildRequires:	python3-hatch-vcs
BuildRequires:	python3-hatchling
BuildRequires:	python3-installer
BuildRequires:	python3-setuptools >= 1:61
%if %{with tests}
BuildRequires:	python3-devel-tools >= 1:3.8
BuildRequires:	python3-fixtures >= 2.0
BuildRequires:	python3-testresources
BuildRequires:	python3-testscenarios
%endif
BuildRequires:	rpmbuild(macros) >= 2.044
%if %{with doc}
BuildRequires:	python3-fixtures >= 2.0
BuildRequires:	sphinx-pdg-3
%endif
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
testtools is a set of extensions to the Python standard library's unit
testing framework.

%description -l pl.UTF-8
testtools to zestaw rozszerzeń szkieletu testów jednostkowych z
biblioteki standardowej Pythona.

%package doc
Summary:	Documentation for Python testttools module
Summary(pl.UTF-8):	Dokumentacja do pakietu Pythona testttools
Group:		Documentation
Requires:	%{name} = %{version}-%{release}

%description doc
This package contains HTML documentation for Python testttools module.

%description doc -l pl.UTF-8
Dokumentacja HTML do pakietu Pythona testttools.

%prep
%setup -q -n testtools-%{version}

# Twisted support is optional and currently broken
%{__sed} -i -e '/twistedsupport,/d' testtools/tests/__init__.py

%build
# setup.py exists, but only hatching build stores proper version information
%py3_build_pyproject

%if %{with tests}
%{__python3} -m zipfile -e build-3/*.whl build-3-test
# use explicit plugins list for reliable builds (delete PYTEST_PLUGINS if empty)
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTEST_PLUGINS= \
PYTHONPATH="$PWD/build-3-test" \
%{__python3} -m testtools.run testtools.tests.test_suite
%endif

%if %{with doc}
PYTHONPATH=$(pwd) \
%{__make} -C doc html \
	SPHINXBUILD=sphinx-build-3
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py3_install_pyproject

%{__rm} -r $RPM_BUILD_ROOT%{py3_sitescriptdir}/testtools/tests/{matchers,twistedsupport}
%{__rm} $RPM_BUILD_ROOT%{py3_sitescriptdir}/testtools/tests/{__init__,samplecases,test_*}.py* \
	$RPM_BUILD_ROOT%{py3_sitescriptdir}/testtools/tests/__pycache__/{__init__,samplecases,test_*}.*.py*

# replace selftests __init__ by empty stub
touch $RPM_BUILD_ROOT%{py3_sitescriptdir}/testtools/tests/__init__.py
%py3_comp $RPM_BUILD_ROOT%{py3_sitescriptdir}/testtools/tests
%py3_ocomp $RPM_BUILD_ROOT%{py3_sitescriptdir}/testtools/tests

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc LICENSE NEWS README.rst
%dir %{py3_sitescriptdir}/testtools
%{py3_sitescriptdir}/testtools/*.py
%{py3_sitescriptdir}/testtools/__pycache__
%{py3_sitescriptdir}/testtools/matchers
%{py3_sitescriptdir}/testtools/testresult
%{py3_sitescriptdir}/testtools/tests
%{py3_sitescriptdir}/testtools/twistedsupport
%{py3_sitescriptdir}/testtools-%{version}.dist-info

%if %{with doc}
%files doc
%defattr(644,root,root,755)
%doc doc/_build/html/{_static,*.html,*.js}
%endif
%changelog
* Sat Jun 07 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-testtools.git;a=log;h=master

* Sat Jun 07 2025 Jan Rękorajski <baggins@pld-linux.org> f0a223a
- rel 2, disable broken twisted tests

* Mon May 26 2025 Jakub Bogusz <qboosh@pld-linux.org> 237ae2e
- python-testtools.spec updated to 2.7.2 for python 3.8+

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 737905d
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 17eac08
- python 3.13 rebuild

* Sun Mar 09 2025 Jan Rękorajski <baggins@pld-linux.org> c5cb31f
- use patch -P

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> 7c2a5bd
- rebuild with tests and docs

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 0717538
- rebuild with python 3.10

* Thu Mar 17 2022 Jakub Bogusz <qboosh@pld-linux.org> 65dcb6f
- updated to 2.4.0
- updated deps patch
- removed obsolete py37 patch

* Sun Feb 28 2021 Jan Palus <atler@pld-linux.org> a070092
- release 4 (by relup.sh)

* Fri Jan 10 2020 Jakub Bogusz <qboosh@pld-linux.org> 4737b5e
- release 3

* Fri Jan 10 2020 Jakub Bogusz <qboosh@pld-linux.org> 1c2e6c7
- added py37 patch (adjust exception repr)

* Thu Jan 09 2020 Jakub Bogusz <qboosh@pld-linux.org> d839dbe
- added deps patch (don't use backports under python 3.5+)

* Fri Jan 10 2020 Jakub Bogusz <qboosh@pld-linux.org> a3d231f
- updated tests running
- removed duplicate python*-extras dependency (already autogenerated)

* Fri Jan 10 2020 Jakub Bogusz <qboosh@pld-linux.org> ecce750
- added tests-nosource patch (fix tests without modules source available)

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> b49cdb9
- rebuild with python 3.8
- release 2 (by relup.sh)

* Wed Jul 04 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 18e5479
- up to 2.3.0

* Mon Jul 02 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> cd28ea4
- release 4 (by relup.sh)

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> d600fa0
- python 3.6
- release 3 (by relup.sh)

* Mon Mar 14 2016 Jakub Bogusz <qboosh@pld-linux.org> af0637e
- package testtools.tests.helpers (useful for external packages tests); release 2

* Sat Mar 05 2016 Jakub Bogusz <qboosh@pld-linux.org> f4bc906
- updated to 1.1.0 (the last version that doesn't depend explicitly on unittest2)

